// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from smacc2_msgs:msg/SmaccContainerStatus.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STATUS__TRAITS_HPP_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STATUS__TRAITS_HPP_

#include "smacc2_msgs/msg/detail/smacc_container_status__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const smacc2_msgs::msg::SmaccContainerStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path: ";
    value_to_yaml(msg.path, out);
    out << "\n";
  }

  // member: initial_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.initial_states.size() == 0) {
      out << "initial_states: []\n";
    } else {
      out << "initial_states:\n";
      for (auto item : msg.initial_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: active_states
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.active_states.size() == 0) {
      out << "active_states: []\n";
    } else {
      out << "active_states:\n";
      for (auto item : msg.active_states) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: local_data
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "local_data: ";
    value_to_yaml(msg.local_data, out);
    out << "\n";
  }

  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info: ";
    value_to_yaml(msg.info, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const smacc2_msgs::msg::SmaccContainerStatus & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<smacc2_msgs::msg::SmaccContainerStatus>()
{
  return "smacc2_msgs::msg::SmaccContainerStatus";
}

template<>
inline const char * name<smacc2_msgs::msg::SmaccContainerStatus>()
{
  return "smacc2_msgs/msg/SmaccContainerStatus";
}

template<>
struct has_fixed_size<smacc2_msgs::msg::SmaccContainerStatus>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<smacc2_msgs::msg::SmaccContainerStatus>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<smacc2_msgs::msg::SmaccContainerStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STATUS__TRAITS_HPP_
