// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from smacc2_msgs:msg/SmaccEventGenerator.idl
// generated code does not contain a copyright notice
#include "smacc2_msgs/msg/detail/smacc_event_generator__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `type_name`
// Member `object_tag`
#include "rosidl_runtime_c/string_functions.h"

bool
smacc2_msgs__msg__SmaccEventGenerator__init(smacc2_msgs__msg__SmaccEventGenerator * msg)
{
  if (!msg) {
    return false;
  }
  // index
  // type_name
  if (!rosidl_runtime_c__String__init(&msg->type_name)) {
    smacc2_msgs__msg__SmaccEventGenerator__fini(msg);
    return false;
  }
  // object_tag
  if (!rosidl_runtime_c__String__init(&msg->object_tag)) {
    smacc2_msgs__msg__SmaccEventGenerator__fini(msg);
    return false;
  }
  return true;
}

void
smacc2_msgs__msg__SmaccEventGenerator__fini(smacc2_msgs__msg__SmaccEventGenerator * msg)
{
  if (!msg) {
    return;
  }
  // index
  // type_name
  rosidl_runtime_c__String__fini(&msg->type_name);
  // object_tag
  rosidl_runtime_c__String__fini(&msg->object_tag);
}

bool
smacc2_msgs__msg__SmaccEventGenerator__are_equal(const smacc2_msgs__msg__SmaccEventGenerator * lhs, const smacc2_msgs__msg__SmaccEventGenerator * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // index
  if (lhs->index != rhs->index) {
    return false;
  }
  // type_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->type_name), &(rhs->type_name)))
  {
    return false;
  }
  // object_tag
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->object_tag), &(rhs->object_tag)))
  {
    return false;
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccEventGenerator__copy(
  const smacc2_msgs__msg__SmaccEventGenerator * input,
  smacc2_msgs__msg__SmaccEventGenerator * output)
{
  if (!input || !output) {
    return false;
  }
  // index
  output->index = input->index;
  // type_name
  if (!rosidl_runtime_c__String__copy(
      &(input->type_name), &(output->type_name)))
  {
    return false;
  }
  // object_tag
  if (!rosidl_runtime_c__String__copy(
      &(input->object_tag), &(output->object_tag)))
  {
    return false;
  }
  return true;
}

smacc2_msgs__msg__SmaccEventGenerator *
smacc2_msgs__msg__SmaccEventGenerator__create()
{
  smacc2_msgs__msg__SmaccEventGenerator * msg = (smacc2_msgs__msg__SmaccEventGenerator *)malloc(sizeof(smacc2_msgs__msg__SmaccEventGenerator));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(smacc2_msgs__msg__SmaccEventGenerator));
  bool success = smacc2_msgs__msg__SmaccEventGenerator__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
smacc2_msgs__msg__SmaccEventGenerator__destroy(smacc2_msgs__msg__SmaccEventGenerator * msg)
{
  if (msg) {
    smacc2_msgs__msg__SmaccEventGenerator__fini(msg);
  }
  free(msg);
}


bool
smacc2_msgs__msg__SmaccEventGenerator__Sequence__init(smacc2_msgs__msg__SmaccEventGenerator__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  smacc2_msgs__msg__SmaccEventGenerator * data = NULL;
  if (size) {
    data = (smacc2_msgs__msg__SmaccEventGenerator *)calloc(size, sizeof(smacc2_msgs__msg__SmaccEventGenerator));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = smacc2_msgs__msg__SmaccEventGenerator__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        smacc2_msgs__msg__SmaccEventGenerator__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
smacc2_msgs__msg__SmaccEventGenerator__Sequence__fini(smacc2_msgs__msg__SmaccEventGenerator__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      smacc2_msgs__msg__SmaccEventGenerator__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

smacc2_msgs__msg__SmaccEventGenerator__Sequence *
smacc2_msgs__msg__SmaccEventGenerator__Sequence__create(size_t size)
{
  smacc2_msgs__msg__SmaccEventGenerator__Sequence * array = (smacc2_msgs__msg__SmaccEventGenerator__Sequence *)malloc(sizeof(smacc2_msgs__msg__SmaccEventGenerator__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = smacc2_msgs__msg__SmaccEventGenerator__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
smacc2_msgs__msg__SmaccEventGenerator__Sequence__destroy(smacc2_msgs__msg__SmaccEventGenerator__Sequence * array)
{
  if (array) {
    smacc2_msgs__msg__SmaccEventGenerator__Sequence__fini(array);
  }
  free(array);
}

bool
smacc2_msgs__msg__SmaccEventGenerator__Sequence__are_equal(const smacc2_msgs__msg__SmaccEventGenerator__Sequence * lhs, const smacc2_msgs__msg__SmaccEventGenerator__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!smacc2_msgs__msg__SmaccEventGenerator__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
smacc2_msgs__msg__SmaccEventGenerator__Sequence__copy(
  const smacc2_msgs__msg__SmaccEventGenerator__Sequence * input,
  smacc2_msgs__msg__SmaccEventGenerator__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(smacc2_msgs__msg__SmaccEventGenerator);
    smacc2_msgs__msg__SmaccEventGenerator * data =
      (smacc2_msgs__msg__SmaccEventGenerator *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!smacc2_msgs__msg__SmaccEventGenerator__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          smacc2_msgs__msg__SmaccEventGenerator__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!smacc2_msgs__msg__SmaccEventGenerator__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
