// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from smacc2_msgs:msg/SmaccContainerStructure.idl
// generated code does not contain a copyright notice

#ifndef SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STRUCTURE__TRAITS_HPP_
#define SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STRUCTURE__TRAITS_HPP_

#include "smacc2_msgs/msg/detail/smacc_container_structure__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const smacc2_msgs::msg::SmaccContainerStructure & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_yaml(msg.header, out, indentation + 2);
  }

  // member: path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "path: ";
    value_to_yaml(msg.path, out);
    out << "\n";
  }

  // member: children
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.children.size() == 0) {
      out << "children: []\n";
    } else {
      out << "children:\n";
      for (auto item : msg.children) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: internal_outcomes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.internal_outcomes.size() == 0) {
      out << "internal_outcomes: []\n";
    } else {
      out << "internal_outcomes:\n";
      for (auto item : msg.internal_outcomes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: outcomes_from
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.outcomes_from.size() == 0) {
      out << "outcomes_from: []\n";
    } else {
      out << "outcomes_from:\n";
      for (auto item : msg.outcomes_from) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: outcomes_to
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.outcomes_to.size() == 0) {
      out << "outcomes_to: []\n";
    } else {
      out << "outcomes_to:\n";
      for (auto item : msg.outcomes_to) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: container_outcomes
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.container_outcomes.size() == 0) {
      out << "container_outcomes: []\n";
    } else {
      out << "container_outcomes:\n";
      for (auto item : msg.container_outcomes) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const smacc2_msgs::msg::SmaccContainerStructure & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<smacc2_msgs::msg::SmaccContainerStructure>()
{
  return "smacc2_msgs::msg::SmaccContainerStructure";
}

template<>
inline const char * name<smacc2_msgs::msg::SmaccContainerStructure>()
{
  return "smacc2_msgs/msg/SmaccContainerStructure";
}

template<>
struct has_fixed_size<smacc2_msgs::msg::SmaccContainerStructure>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<smacc2_msgs::msg::SmaccContainerStructure>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<smacc2_msgs::msg::SmaccContainerStructure>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // SMACC2_MSGS__MSG__DETAIL__SMACC_CONTAINER_STRUCTURE__TRAITS_HPP_
